
#include "text.h"
#include <iostream>
#include <fstream>

// Constructor
Text::Text(std::string bitmapFile, std::string textFile, SDL_Renderer *renderer)
{
	// Carga los offsets desde el fichero
	initOffsetFromFile(textFile);

	// Crea los objetos
	texture = new LTexture(renderer, bitmapFile);
	sprite = new Sprite({0, 0, boxWidth, boxHeight}, texture, renderer);
}

// Destructor
Text::~Text()
{
	delete texture;
	delete sprite;
}

// Escribe texto en pantalla
void Text::write(int x, int y, std::string text, int kerning, int lenght)
{
	int shift = 0;

	if (lenght == -1)
		lenght = text.length();

	for (int i = 0; i < lenght; ++i)
	{
		sprite->setSpriteClip(offset[int(text[i])].x, offset[int(text[i])].y, sprite->getWidth(), sprite->getHeight());
		sprite->setPosX(x + shift);
		sprite->setPosY(y);
		sprite->render();
		shift += (offset[int(text[i])].w + kerning);
	}
}

// Escribe el texto con colores
void Text::writeColored(int x, int y, std::string text, color_t color, int kerning, int lenght)
{
	sprite->getTexture()->setColor(color.r, color.g, color.b);
	write(x, y, text, kerning, lenght);
	sprite->getTexture()->setColor(255, 255, 255);
}

// Escribe el texto con sombra
void Text::writeShadowed(int x, int y, std::string text, color_t color, Uint8 shadowDistance, int kerning, int lenght)
{
	sprite->getTexture()->setColor(color.r, color.g, color.b);
	write(x + shadowDistance, y + shadowDistance, text, kerning, lenght);
	sprite->getTexture()->setColor(255, 255, 255);
	write(x, y, text, kerning, lenght);
}

// Escribe el texto centrado en un punto x
void Text::writeCentered(int x, int y, std::string text, int kerning, int lenght)
{
	x -= (Text::lenght(text, kerning) / 2);
	write(x, y, text, kerning, lenght);
}

// Escribe texto con extras
void Text::writeDX(Uint8 flags, int x, int y, std::string text, int kerning, color_t textColor, Uint8 shadowDistance, color_t shadowColor, int lenght)
{
	const bool centered = ((flags & TXT_CENTER) == TXT_CENTER);
	const bool shadowed = ((flags & TXT_SHADOW) == TXT_SHADOW);
	const bool colored = ((flags & TXT_COLOR) == TXT_COLOR);
	const bool stroked = ((flags & TXT_STROKE) == TXT_STROKE);

	if (centered)
		x -= (Text::lenght(text, kerning) / 2);

	if (shadowed)
		writeColored(x + shadowDistance, y + shadowDistance, text, shadowColor, kerning, lenght);

	if (stroked)
	{
		writeColored(x + shadowDistance, y + shadowDistance, text, shadowColor, kerning, lenght);
		writeColored(x - shadowDistance, y + shadowDistance, text, shadowColor, kerning, lenght);
		writeColored(x + shadowDistance, y - shadowDistance, text, shadowColor, kerning, lenght);
		writeColored(x - shadowDistance, y - shadowDistance, text, shadowColor, kerning, lenght);

		writeColored(x, y + shadowDistance, text, shadowColor, kerning, lenght);
		writeColored(x, y - shadowDistance, text, shadowColor, kerning, lenght);
		writeColored(x + shadowDistance, y, text, shadowColor, kerning, lenght);
		writeColored(x - shadowDistance, y, text, shadowColor, kerning, lenght);
	}

	if (colored)
		writeColored(x, y, text, textColor, kerning, lenght);
	else
		write(x, y, text, kerning, lenght);
}

// Obtiene la longitud en pixels de una cadena
int Text::lenght(std::string text, int kerning)
{
	int shift = 0;

	for (int i = 0; i < (int)text.length(); ++i)
		shift += (offset[int(text[i])].w + kerning);

	// Descuenta el kerning del último caracter
	return shift - kerning;
}

// Inicializa el vector de offsets desde un fichero
void Text::initOffsetFromFile(std::string file)
{
	// Inicializa a cero el vector con las coordenadas
	for (int i = 0; i < 128; ++i)
	{
		offset[i].x = 0;
		offset[i].y = 0;
		offset[i].w = 0;
	}

	// Abre el fichero para leer los valores
	const std::string filename = file.substr(file.find_last_of("\\/") + 1).c_str();
	std::ifstream rfile(file);

	if (rfile.is_open() && rfile.good())
	{
		std::string buffer;

		// Lee los dos primeros valores del fichero
		std::getline(rfile, buffer);
		std::getline(rfile, buffer);
		boxWidth = std::stoi(buffer);

		std::getline(rfile, buffer);
		std::getline(rfile, buffer);
		boxHeight = std::stoi(buffer);

		// lee el resto de datos del fichero
		int index = 32;
		int line_read = 0;
		while (std::getline(rfile, buffer))
		{
			// Almacena solo las lineas impares
			if (line_read % 2 == 1)
				offset[index++].w = std::stoi(buffer);

			// Limpia el buffer
			buffer.clear();
			line_read++;
		};

		// Cierra el fichero
		printf("Text loaded: %s\n", filename.c_str());
		rfile.close();
	}

	// El fichero no se puede abrir
	else
	{
		printf("Warning: Unable to open %s file\n", filename.c_str());
	}

	// Establece las coordenadas para cada caracter ascii de la cadena y su ancho
	for (int i = 32; i < 128; ++i)
	{
		offset[i].x = ((i - 32) % 15) * boxWidth;
		offset[i].y = ((i - 32) / 15) * boxHeight;
	}
}

// Devuelve el valor de la variable
int Text::getCharacterSize()
{
	return boxWidth;
}

// Recarga la textura
void Text::reLoadTexture()
{
	texture->reLoad();
}